-- Do not manually edit this file, it was auto-generated by dillonkearns/elm-graphql
-- https://github.com/dillonkearns/elm-graphql


module UsersApi.Query exposing (..)

import CustomScalarCodecs
import Graphql.Internal.Builder.Argument as Argument exposing (Argument)
import Graphql.Internal.Builder.Object as Object
import Graphql.Internal.Encode as Encode exposing (Value)
import Graphql.Operation exposing (RootMutation, RootQuery, RootSubscription)
import Graphql.OptionalArgument exposing (OptionalArgument(..))
import Graphql.SelectionSet exposing (SelectionSet)
import Json.Decode as Decode exposing (Decoder)
import UsersApi.InputObject
import UsersApi.Interface
import UsersApi.Object
import UsersApi.Scalar
import UsersApi.Union


users : SelectionSet decodesTo UsersApi.Object.User -> SelectionSet (List decodesTo) RootQuery
users object_ =
    Object.selectionForCompositeField "users" [] object_ (identity >> Decode.list)


type alias UserRequiredArguments =
    { id : String }


user : UserRequiredArguments -> SelectionSet decodesTo UsersApi.Object.User -> SelectionSet decodesTo RootQuery
user requiredArgs object_ =
    Object.selectionForCompositeField "user" [ Argument.required "id" requiredArgs.id Encode.string ] object_ identity


current : SelectionSet decodesTo UsersApi.Object.User -> SelectionSet decodesTo RootQuery
current object_ =
    Object.selectionForCompositeField "current" [] object_ identity
